#include <cstdio>
#include <iostream>
#include <string>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/un.h>
#include <unistd.h>

#include "MTESTControl.h"

#ifndef MTEST_SERVER_H
#define MTEST_SERVER_H

class MTESTServer
//This class describes a server providing connection through unix domain socket to an MTESTControl object
{
  public:
    MTESTServer(const std::string socket_path, int pending_list_size):path(socket_path){pending_no=pending_list_size; close_connection=false;};//Constructor
    ~MTESTServer(){};//Destructor
    bool Run(MTESTControl &mtc);//This method runs the socket, which communicates with (returns with success or fail)
  private:
    //private methods
    int initsocket(const std::string &s_path, int pend_list_size);//This method initializes a socket, whose path is s_path and the size of pending connections is pend_list_size. It returns with the file descriptor or error codes
    bool accept_and_close_loop(int descriptor_socket, MTESTControl &mtc);//This method accepts the incoming requests, communicates and closes the socket inputs are the socket descriptor and the MTESTControl object. Returns with success or error
    void closesocket(int descriptor_socket){close(descriptor_socket);}//Close the opened socket whose descriptor is descriptor_socket
    bool handle_client(const int client, MTESTControl &mtc);//This member handles the accepted client connection: transfers the received message to control, then transmit the answer. Returns with success or fail
    //private members
    std::string path;//Socket path
    int pending_no;//Number of allowed pending connections
    bool close_connection;//Close connection
};
#endif