#include <vector>
#include <algorithm>

#ifndef THERMOMETER_H
#define THERMOMETER_H

//Tested in 2015.8.15 with KD48P and OHM classes

template <class T> class Vec: public std::vector<T>
//Safe template class to store vectorrs
{
    public:
	Vec():std::vector<T>(){}
	Vec(int s):std::vector<T>(s){}
	
	T& operator[](int i){ return this->at(i);}
	const T& operator[](int i) const{ return this->at(i);} 
};


class Thermometer
//This class describes a very simple thermometer registration device
{
  public:
    //methods
      Thermometer(int number_of_channel){channels= new Vec<bool>(number_of_channel); temperatures= new double [number_of_channel]; for(int i=0; i<(int)channels->size(); i++) channels->at(i)=false;};//Constructor
      ~Thermometer(){delete channels; delete [] temperatures;};//Destructor
      Vec<double> Temperature();//Returns with the temperature of the device on the previously set channels, -5000: error
      void enabledisableChannel(int channel_no, bool enabledisable=false){channels->at(channel_no)=enabledisable; return;};//Enable(t)/disable(f) the temperature channel (from 0), which provides temperatures
      int getNoChannels(){return channels->size();};//Returns with the number of channels
  protected:
      virtual void getTempHW(double *result)=0;//Returns with the temperatures: , should be implemented in child class
      double *temperatures;//Temperatures, which used to pass actual values to the Temperature method: -5000: error
  private:
      Vec<bool> *channels;//Stores the channels enabled/disabled status  
};

#endif