#include <cstdio>
#include <iostream>
#include <sstream>
#include <string>
#include <sys/socket.h>
#include <sys/un.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
  struct sockaddr_un address;//Defines unix domain socket address structure
  int sock;//File descriptor of the socket
  
  //Create MTEST controller object
  //MTESTControl mc();
  
  //Create socket
  if((sock=socket(PF_LOCAL, SOCK_STREAM,0))<0)
  {
    perror("Initialisattion of socket");
    return -1;
  }
  

  address.sun_family=AF_UNIX;//Unix domain socket
  strcpy(address.sun_path,"./mtest_socket");//Define path
  socklen_t addr_length=(socklen_t)(sizeof(address.sun_family)+strlen(address.sun_path));//Determine size
  
  //Connecting to the socket
  if(connect(sock,(struct sockaddr *) &address, addr_length))
  {
    perror("Connecting has not been succeeded!");
    return -1;
  }
  

  for(int i=1; i<argc; i++)
  {
    std::stringstream ss;
    ss<<" "<<argv[i];
    if(i==argc-1) ss<<"\n";
    std::string temporary=ss.str();
    if(write(sock,temporary.c_str(),temporary.length())!=(ssize_t) temporary.length())
    {
      perror("Writing socket");
      return -1;
    }
  }
  
  int datacnts;
  char buffer[256];
  std::string answer;
  while((datacnts=read(sock,buffer,sizeof(buffer))>0)||(answer.size()==0)) answer.append(buffer);
  answer.erase(answer.find("\n"));//Reduce the size
  std::cout<<answer<<std::endl;
  
  //Close connection
  close(sock);
  return 0;
}