#include <iostream>
#include <fstream>
#include <string>
#include <unistd.h>
#include "kd48p.h"
#include "Lock.h"

int main(int argc, char *argv[])
{
  if((argc!=3)&&(argc!=2))
  {
    std::cout<<"This program stops, programs and starts the temperature controller"<<std::endl;
    std::cout<<"USAGE: "<<argv[0]<<" temperature_in_C heating_speed_temperature/60min"<<std::endl;
    std::cout<<"\tor: "<<argv[0]<<" stop"<<std::endl;
    return -1;
  }
  std::string str(argv[1]);

  if ((argc==2)&&(str!="stop"))
  {
    std::cout<<"Error: Please, use the correct \"stop\" keyword!"<<std::endl;
    return -1;
  }

  Modbus mb("haga_controller",19200,8,'N',1,1.0);
  KD48P regulator(&mb,1);
  
  std::cout<<"Switching off the regulator: "<<std::endl;
  bool get_out=false;
  Lock lck("temperature_lock");
  lck.lock(true);
  do
  {
    get_out=regulator.switchOff(true);
    std::cout<<(get_out ? "OK" : "Failed")<<std::endl;
    sleep(2u);
  }while(!get_out);
  if(argc==3)
  {
    std::cout<<"Programming the regulator: "<<std::endl;
    get_out=false;
    do
    {
      get_out=regulator.SetProgram(0, 0, 0, std::stod(argv[2]), std::stoi(argv[1]), 0, true);
      std::cout<<(get_out ? "OK" : "Failed")<<std::endl;
      sleep(2u);
    }while(!get_out);
    std::cout<<"Switching on the regulator: "<<std::endl;
    get_out=false;
    do
    {
      get_out=regulator.switchOn(true);
      std::cout<<(get_out ? "OK" : "Failed")<<std::endl;
      sleep(2u);
    }while(!get_out);
  }
  lck.lock(false);
  
  return 0;
}
